VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   735
      Left            =   840
      TabIndex        =   0
      Top             =   600
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New illustrator.Application
'Start talking to Illustrator so you can remove all unused palette items.

Private Sub Command1_Click()
    doProcessDocument ("")
End Sub

Private Sub doProcessDocument(myDocumentName)
    'code to process file goes here
    deleteUnusedSwatches
    deleteUnusedSymbols
    deleteAllStyles
    'exportDocument ("illustrator")
End Sub
'
Private Sub deleteUnusedSwatches()
    Dim mySwatchNum, mySwatch, myColorUsed, myPathItem
    'Start talking to Illustrator so you can remove all unused swatches.
    If myApp.Documents.Count > 0 Then
        'Check to make sure a document is open in Illustrator before we assume anything.
        For mySwatchNum = myApp.Documents(1).Swatches.Count To 1 Step -1
            Set mySwatch = myApp.Documents(1).Swatches(mySwatchNum)
            'Begin a loop through all of the swatches in the document.
            'Within the loop, store a reference to the current swatch in a variable called [myswatch].
            myColorUsed = False
            'Set up a simple flag variable to keep track of whether we find the color used or not in the below loop.
            For Each myPathItem In myApp.Documents(1).PathItems
                'Next loop through all of the paths in the document, checking for the current color swatch in fill or stroke color.
                If myPathItem.FillColor.Color = mySwatch.Color.Color Then
                    Select Case myPathItem.FillColor.Color
                        Case aiColorCMYK
                            If myPathItem.FillColor.CMYK.Black = mySwatch.Color.CMYK.Black And myPathItem.FillColor.CMYK.Cyan = mySwatch.Color.CMYK.Cyan And myPathItem.FillColor.CMYK.Magenta = mySwatch.Color.CMYK.Magenta And myPathItem.FillColor.CMYK.Yellow = mySwatch.Color.CMYK.Yellow Then
                                myColorUsed = True
                            End If
                        Case aiColorGradient
                            If myPathItem.FillColor.Gradient.Gradient.Name = mySwatch.Color.Gradient.Gradient.Name Then
                                myColorUsed = True
                            End If
                        Case aiColorGray
                            If myPathItem.FillColor.Gray.Gray = mySwatch.Color.Gray.Gray Then
                                myColorUsed = True
                            End If
                        Case aiColorPattern
                            If myPathItem.FillColor.Pattern.Pattern.Name = mySwatch.Color.Pattern.Pattern.Name Then
                                myColorUsed = True
                            End If
                        Case aiColorRGB
                            If myPathItem.FillColor.RGB.Blue = mySwatch.Color.RGB.Blue And myPathItem.FillColor.RGB.Green = mySwatch.Color.RGB.Green And myPathItem.FillColor.RGB.Red = mySwatch.Color.RGB.Red Then
                                myColorUsed = True
                            End If
                        Case aiColorSpot
                            If myPathItem.FillColor.Spot.Spot.Name = mySwatch.Color.Spot.Spot.Name Then
                                myColorUsed = True
                            End If
                    End Select
                End If
                If myPathItem.StrokeColor.Color = mySwatch.Color.Color Then
                    Select Case myPathItem.StrokeColor.Color
                        Case aiColorCMYK
                            If myPathItem.StrokeColor.CMYK.Black = mySwatch.Color.CMYK.Black And myPathItem.StrokeColor.CMYK.Cyan = mySwatch.Color.CMYK.Cyan And myPathItem.StrokeColor.CMYK.Magenta = mySwatch.Color.CMYK.Magenta And myPathItem.StrokeColor.CMYK.Yellow = mySwatch.Color.CMYK.Yellow Then
                                myColorUsed = True
                            End If
                        Case aiColorGradient
                            If myPathItem.StrokeColor.Gradient.Name = mySwatch.Color.Gradient.Name Then
                                myColorUsed = True
                            End If
                        Case aiColorGray
                            If myPathItem.StrokeColor.Gray.Gray = mySwatch.Color.Gray.Gray Then
                                myColorUsed = True
                            End If
                        Case aiColorPattern
                            If myPathItem.StrokeColor.Pattern.Name = mySwatch.Color.Pattern.Name Then
                                myColorUsed = True
                            End If
                        Case aiColorRGB
                            If myPathItem.StrokeColor.RGB.Blue = mySwatch.Color.RGB.Blue And myPathItem.StrokeColor.RGB.Green = mySwatch.Color.RGB.Green And myPathItem.StrokeColor.RGB.Red = mySwatch.Color.RGB.Red Then
                                myColorUsed = True
                            End If
                        Case aiColorSpot
                            If myPathItem.StrokeColor.Spot.Name = mySwatch.Color.Spot.Name Then
                                myColorUsed = True
                            End If
                    End Select
                End If
                'If we find that the swatch color is used in the stroke or fill color of the current path,
                'then we set the flag variable so we know below not to delete the swatch!
                If myColorUsed Then Exit For
            Next
            If myColorUsed = False Then
                'If the flag variable is false, we now know the swatch is unused.
                myApp.Documents(1).Swatches.Remove (mySwatch)
                'Now we attempt to delete the swatch from the document.
            End If
        Next
    End If
End Sub

Private Sub deleteUnusedSymbols()
    Dim mySymbolNum, mySymbol, mySymbolUsed, mySymbolItem
    If myApp.Documents.Count > 0 Then
        'Check to make sure a document is open in Illustrator before we assume anything.
        For mySymbolNum = myApp.Documents(1).Symbols.Count To 1 Step -1
            Set mySymbol = myApp.Documents(1).Symbols(mySymbolNum)
            'Begin a loop through all of the symbols in the document.
            mySymbolUsed = False
            For Each mySymbolItem In myApp.Documents(1).SymbolItems
                'Next loop through all of the symbol art items in the document
                'checking for ones that use the current symbol.
                If mySymbolItem.Symbol.Name = mySymbol.Name Then
                    mySymbolUsed = True
                    Exit For
                End If
            Next
            If mySymbolUsed = False Then
                'If flag variable is false then we now know the symbol is unused.
                myApp.Documents(1).Symbols.Remove (mySymbol)
                'Now we can attempt to delete the symbol from the document.
            End If
        Next
    End If
End Sub

Private Sub deleteAllStyles()
    If myApp.Documents.Count > 0 Then
        'Check to make sure a document is open in Illustrator before we assume anything.
        myApp.Documents(1).ArtStyles.RemoveAll
        'Now we can attempt to delete all styles from the document.
    End If
End Sub

Private Sub exportDocument(myFormat)
    Dim myOriginalFile, myNewPath, myCharNum, myExportOptions, myColor
    myOriginalFile = myApp.Documents(1).FullName
    myNewPath = myOriginalFile
    If InStr(myOriginalFile, ".") > 0 Then
        myNewPath = Mid(myOriginalFile, 1, InStrRev(myOriginalFile, ".") - 1)
    End If
    Select Case myFormat
        Case "eps"
            myNewPath = myNewPath & ".eps"
            Set myExportOptions = New illustrator.EPSSaveOptions
            myExportOptions.CMYKPostScript = True
            myExportOptions.Compatibility = aiIllustrator10
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedLinkedFiles = True
            myExportOptions.IncludeDocumentThumbnails = True
            myExportOptions.PostScript = aiLevel2
            myExportOptions.Preview = aiColorTIFF
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreOriginalAfterSave Then
                myApp.Open (myOriginalFile)
            End If
        Case "flash"
            myNewPath = myNewPath & ".swf"
            Set myExportOptions = New illustrator.ExportOptionsFlash
            myExportOptions.ArtBoardClipping = True
            myExportOptions.CurveQuality = 9
            myExportOptions.ExportStyle = aiLayersAsFrames
            myExportOptions.FrameRate = 15#
            myExportOptions.GenerateHTML = False
            myExportOptions.ImageFormat = aiLossy
            myExportOptions.JPEGMethod = aiJPEGOptimized
            myExportOptions.JPEGQuality = 7
            myExportOptions.Looping = False
            myExportOptions.ReadOnly = False
            myExportOptions.Replacing = aiSaveChanges
            myExportOptions.Resolution = 72#
            myApp.Documents(1).Export myNewPath, aiFlash, myExportOptions
            
        Case "gif"
            myNewPath = myNewPath & ".gif"
            Set myExportOptions = New illustrator.ExportOptionsGIF
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.InfoLossPercent = 0
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New illustrator.RGBColor
            myColor.Red = 0#
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiGIF, myExportOptions
        
        Case "jpeg"
            myNewPath = myNewPath & ".jpg"
            Set myExportOptions = New illustrator.ExportOptionsJPEG
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.BlurAmount = 0#
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.Optimization = True
            myExportOptions.QualitySetting = 70
            myExportOptions.SaveAsHTML = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiJPEG, myExportOptions
        
        Case "pdf"
            myNewPath = myNewPath & ".pdf"
            Set myExportOptions = New illustrator.PDFSaveOptions
            myExportOptions.ColorCompression = aiJPEGHigh
            myExportOptions.ColorDownsampling = 300#
            myExportOptions.Compatibility = aiAcrobat4
            myExportOptions.CompressArt = True
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedICCProfile = False
            myExportOptions.FontSubsetThreshold = 0#
            myExportOptions.GenerateThumbnails = True
            myExportOptions.GrayscaleCompression = aiJPEGHigh
            myExportOptions.GrayscaleDownsampling = 200#
            myExportOptions.MonochromeCompression = aiCCIT3
            myExportOptions.MonochromeDownsampling = 600#
            myExportOptions.PreserveEditability = False
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreOriginalAfterSave Then
                myApp.Open (myOriginalFile)
            End If
        
        Case "png24"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New illustrator.ExportOptionsPNG24
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiPNG24, myExportOptions
        
        Case "png8"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New illustrator.ExportOptionsPNG8
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256#
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New illustrator.RGBColor
            myColor.Red = 0
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiPNG8, myExportOptions
            
        Case "svg"
            myNewPath = myNewPath & ".svg"
            Set myExportOptions = New illustrator.ExportOptionsSVG
            myExportOptions.Compressed = False
            myExportOptions.CoordinatePrecision = 5
            myExportOptions.CSSProperties = aiStyleAttributes
            myExportOptions.DocumentEncoding = aiUTF8
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedRasterImages = True
            myExportOptions.FontSubsetting = aiAllGlyphs
            myExportOptions.IncludeFileInfo = True
            myExportOptions.IncludeVariablesAndDatasets = False
            myExportOptions.OptimizeForSVGViewer = True
            myExportOptions.PreserveEditability = False
            myExportOptions.Slices = True
            myApp.Documents(1).Export myNewPath, aiSVG, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreOriginalAfterSave Then
                myApp.Open (myOriginalFile)
            End If
            
    End Select
End Sub




