VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   615
      Left            =   1560
      TabIndex        =   0
      Top             =   960
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New Illustrator.Application
Dim myFileSysObject As New FileSystemObject

Private Sub Command1_Click()
    Dim myDesiredResolution, myFilePath, myFolder, myInteractionLevel
    Dim myNum, myWidth, myHeight, myPosition, myTempDoc
    Dim myNewWidth, myNewHeight, myNewResolution, myNewPath
    Dim myRasterItem, myNewRasterItem
    If myApp.Documents.Count > 0 Then
        myDesiredResolution = InputBox("Final output resolution (dpi)", , "300.0")
        myFilePath = myApp.Documents(1).FullName
        If Left(myFilePath, 1) <> "\" Then
            'Check to make sure file has been saved before.
            myFolder = myFileSysObject.GetParentFolderName(myFilePath)
            myInteractionLevel = myApp.UserInteractionLevel
            myApp.UserInteractionLevel = aiDontDisplayAlerts
            If myApp.Documents(1).RasterItems.Count > 0 Then
                myNum = 1
                For Each myRasterItem In myApp.Documents(1).RasterItems
                    myApp.Documents(1).Selection = Empty
                    myRasterItem.Selected = True
                    myWidth = myRasterItem.Width
                    myHeight = myRasterItem.Height
                    myPosition = myRasterItem.Position
                    'Capture existing item's width and height, which will change when the path updates.
                    myApp.Documents(1).Copy
                    'Copy raster item to clipboard to prepare to move to new temporary document.
                    Set myTempDoc = myApp.Documents.Add(myApp.Documents(1).DocumentColorSpace, myWidth, myHeight)
                    'Create new letter-sized document with color space matching our existing document.
                    myTempDoc.Paste
                    'Paste in the raster item we want to optimize.
                    myTempDoc.RasterItems(1).Matrix = myApp.GetIdentityMatrix()
                    'Reset any transformations of raster art.
                    myNewWidth = myTempDoc.RasterItems(1).Width
                    myNewHeight = myTempDoc.RasterItems(1).Height
                    'Gather size of untransformed art to use to calculate percentage resizing to perform in resolution setting.
                    myNewResolution = myDesiredResolution * ((myWidth + myHeight) / (myNewWidth + myNewHeight))
                    myTempDoc.RasterItems(1).Position = Array(((myTempDoc.Width) / 2) - (myNewWidth / 2), ((myTempDoc.Height) / 2) - (myNewHeight / 2))
                    myNewPath = exportPSDDocument(myNewResolution, myNum, myFolder, False)
                    'Export as a Photoshop file with resolution set appropriately, temp doc will be closed in the process.
                    myApp.Documents(1).RasterItems.Remove (myRasterItem)
                    Set myNewRasterItem = myApp.Documents(1).RasterItems.Add
                    myNewRasterItem.File = myNewPath
                    'Link existing raster item to new Photoshop file.
                    myNewRasterItem.Width = myWidth
                    myNewRasterItem.Height = myHeight
                    myNewRasterItem.Position = myPosition
                    myNewRasterItem.Embedded = True
                    'After relinking, the height, width and position of the raster art will shift.
                    'We reset these properties so the new art ends up matching the old art's dimensions,
                    'but now with a resolution that will result in the file being output at the desired resolution.
                Next
            End If
            myApp.UserInteractionLevel = myInteractionLevel
        End If
    End If
End Sub

'4.06 derivative
Private Function exportPSDDocument(myResolution, myNameExtra, mySaveFolder, myRestoreFlag)
    Dim myFormat, myOriginalFile, myNewPath, myExportOptions
    myFormat = "photoshop"
    myOriginalFile = myApp.Documents(1).FullName
    If mySaveFolder <> "" Then
        myNewPath = mySaveFolder & "\"
        If Left(myOriginalFile, 1) <> "\" Then myNewPath = myNewPath & myApp.Documents(1).Name
    Else
        myNewPath = myOriginalFile
    End If
    If InStrRev(myOriginalFile, ".") > Len(myOriginalFile) - 5 Then
        myNewPath = Mid(myOriginalFile, 1, InStrRev(myOriginalFile, ".") - 1)
    End If
    myNewPath = myNewPath & myNameExtra
    Select Case myFormat
        Case "photoshop"
            myNewPath = myNewPath & ".psd"
            Set myExportOptions = New Illustrator.ExportOptionsPhotoshop
            myExportOptions.AntiAliasing = True
            myExportOptions.CompoundShapes = True
            myExportOptions.EditableText = True
            myExportOptions.EmbedICCProfile = False
            myExportOptions.HiddenLayers = False
            myExportOptions.ImageColorSpace = aiImageCMYK
            myExportOptions.ImageMap = True
            myExportOptions.NestedLayers = True
            myExportOptions.Resolution = myResolution
            myExportOptions.Slices = True
            myExportOptions.Warnings = False
            myExportOptions.WriteLayers = True
            myApp.Documents(1).Export myNewPath, aiPhotoshop, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
    End Select
    exportPSDDocument = myNewPath
End Function
