VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.DirListBox Dir1 
      Height          =   2565
      Left            =   240
      TabIndex        =   2
      Top             =   600
      Width           =   4335
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   1680
      TabIndex        =   1
      Top             =   120
      Width           =   2895
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 1
Dim myApp As New Illustrator.Application

Private Sub Drive1_Change()
    Dir1.Path = Drive1.Drive & ":\"
End Sub

Private Sub Command1_Click()
    Dim mySaveFolder, myFormat, myGuidePositions(), myNum
    Dim myPathItem, myDocWidth, myDocHeight, myFirstX, myFirstY
    Dim myHorizontals(), myVerticals()
    Dim myGuidePosition, myGuideX, myGuideY, myXnum, myYnum, myX1, myX2, myY1, myY2
    Dim myCropPath, myPathPoint, myImageWidth, myImageHeight, myGroupItem
    Dim myTempDoc, myCropPosition
    If Dir1.Path <> "" Then
        mySaveFolder = Dir1.Path
        myFormat = "jpeg"
        If myApp.Documents.Count > 0 Then
            myNum = 1
            For Each myPathItem In myApp.Documents(1).PathItems
                If myPathItem.Guides = True Then
                    ReDim Preserve myGuidePositions(myNum)
                    myGuidePositions(myNum) = myPathItem.Position
                    myNum = myNum + 1
                End If
            Next
            'First the script will gather all of the guide positions
            'in the frontmost document into an array.
            myDocWidth = myApp.Documents(1).Width
            myDocHeight = myApp.Documents(1).Height
            
            myFirstX = True
            myFirstY = True
            'Now it is time to prepare to create a list of all of the horizontal locations
            'for guides on the document, as well as a list of the vertical locations.
            
            For Each myGuidePosition In myGuidePositions
                'The loop starts so the script can look at each individual guide position's
                'X (or horizontal) and Y (or vertical) coordinates.
                myGuideX = myGuidePosition(0)
                myGuideY = myGuidePosition(1)
                'The horizontal and vertical coordinates for the current guide position
                'get stored in individual variables so it's easier later on to work with them.
                If myGuideX > 0 And myGuideX <= myDocWidth Then
                    'If the guide is on the document then it is time to add it to the list.
                    If myFirstX Then
                        ReDim myHorizontals(1)
                        myHorizontals(1) = myGuideX
                        myFirstX = False
                    Else
                        If UBound(Filter(myHorizontals, myGuideX)) = -1 Then
                            'Now it is time to make sure the list of horizontal guide positions doesn't
                            'already contain the current horizontal coordinate. We only want one instance of
                            'each X and Y coordinate so we can make rectangles between them later on.
                            'ReDim Preserve myHorizontals(UBound(myHorizontals) + 1)
                            myHorizontals = OrderValues(myHorizontals, myGuideX)
                            'We use a simple function, covered below, to make sure our list of
                            'coordinates stays sorted in order. This is necessary for the code later
                            'to make rectangles based on the guides.
                        End If
                    End If
                End If
                If myGuideY > 0 And myGuideY <= myDocHeight Then
                    'If the guide is on the document then it is time to add it to the list.
                    If myFirstY Then
                        ReDim myVerticals(1)
                        myVerticals(1) = myGuideY
                        myFirstY = False
                    Else
                        If UBound(Filter(myVerticals, myGuideY)) = -1 Then
                            'Now it is time to make sure the list of vertical guide positions doesn't
                            'already contain the current Y coordinate.
                            myVerticals = OrderValues(myVerticals, myGuideY)
                            'We use the simple function OrderValues again to make sure
                            'our list of Y coordinates stays sorted.
                        End If
                    End If
                End If
            Next
            
            For myXnum = 1 To UBound(myHorizontals) - 1
                'Now it is time to prepare to output the cropped rectangular
                'regions of our starting document. This is done by looping through the
                'horizontal guide positions first.
                myX1 = myHorizontals(myXnum)
                myX2 = myHorizontals(myXnum + 1)
                'The current and next X coordinates are stored in variables for easy use later.
                For myYnum = 1 To UBound(myVerticals) - 1
                    'The next loop goes through the vertical guide positions to
                    'gather Y coordinates for our cropping rectangle.
                    myY1 = myVerticals(myYnum)
                    myY2 = myVerticals(myYnum + 1)

                    'The current and next Y coordinates are stored in variables to use below.*)
                    Set myCropPath = myApp.Documents(1).PathItems.Add
                    myCropPath.Stroked = True
                    myCropPath.Filled = False
                    Set myPathPoint = myCropPath.PathPoints.Add
                    myPathPoint.PointType = aiCorner
                    myPathPoint.LeftDirection = Array(myX1, myY1)
                    myPathPoint.RightDirection = Array(myX1, myY1)
                    myPathPoint.Anchor = Array(myX1, myY1)
                    Set myPathPoint = myCropPath.PathPoints.Add
                    myPathPoint.PointType = aiCorner
                    myPathPoint.LeftDirection = Array(myX2, myY1)
                    myPathPoint.RightDirection = Array(myX2, myY1)
                    myPathPoint.Anchor = Array(myX2, myY1)
                    Set myPathPoint = myCropPath.PathPoints.Add
                    myPathPoint.PointType = aiCorner
                    myPathPoint.LeftDirection = Array(myX2, myY2)
                    myPathPoint.RightDirection = Array(myX2, myY2)
                    myPathPoint.Anchor = Array(myX2, myY2)
                    Set myPathPoint = myCropPath.PathPoints.Add
                    myPathPoint.PointType = aiCorner
                    myPathPoint.LeftDirection = Array(myX1, myY2)
                    myPathPoint.RightDirection = Array(myX1, myY2)
                    myPathPoint.Anchor = Array(myX1, myY2)
                    Set myPathPoint = myCropPath.PathPoints.Add
                    myPathPoint.PointType = aiCorner
                    myPathPoint.LeftDirection = Array(myX1, myY1)
                    myPathPoint.RightDirection = Array(myX1, myY1)
                    myPathPoint.Anchor = Array(myX1, myY1)
                    myImageWidth = myCropPath.Width
                    myImageHeight = myCropPath.Height
                    'Make a new path to use as a clipping mask on the document's contents.
                    Set myGroupItem = myApp.Documents(1).GroupItems.Add
                    myGroupItem.MoveToEnd (myApp.Documents(1))
                    'Now create a new group in preparation for setting up the clipping mask.
                    'All clipping masks in Illustrator are built of a group with its [clipping]
                    'property set to true.
                    For myNum = myApp.Documents(1).PageItems.Count - 1 To 1 Step -1
                        If myApp.Documents(1).PageItems(myNum).PageItemType = aiPathItem Then
                            If myApp.Documents(1).PageItems(myNum).PathItem.Guides = False Then
                                myApp.Documents(1).PageItems(myNum).MoveToBeginning (myGroupItem)
                            End If
                        Else
                            myApp.Documents(1).PageItems(myNum).MoveToBeginning (myGroupItem)
                        End If
                    Next
                    'Move all of the art in the document, except guides, into the group so it will get clipped.
                    myGroupItem.Clipped = True
                    myGroupItem.Selected = True
                    myApp.Documents(1).Copy
                    'Select the group and copy it to the clipboard.
                    Set myTempDoc = myApp.Documents.Add(aiDocumentRGBColor, myImageWidth, myImageHeight)
                    'Now it is time to make a new document with the dimensions of the clipping mask and in the RGB color
                    'space so we're ready for outputting a JPEG or GIF for the Web.
                    myTempDoc.Paste
                    'We paste in the clipped art from our source document.
                    myTempDoc.PageItems(1).Position = Array(0#, 0#)
                    'We move the whole clipped group to the page's origin.
                    myCropPosition = myTempDoc.PageItems(2).Position
                    myCropPosition(0) = -myCropPosition(0)
                    myCropPosition(1) = -myCropPosition(1)
                    'Now we calculate the difference between the clipped groups' current position
                    'and the clipping path, which is page item 2, inside of page item 1, which is the group.
                     myCropPosition(1) = myCropPosition(1) + myImageHeight
                    'We add in the offset of the height since Illustrator's page origin is in the lower
                    'left and not the upper left.
                    myTempDoc.PageItems(1).Position = myCropPosition
                    'Finally, we set the position of the clipped group accurately so the artboard lines up
                    'with the clipped art. This will let us use the export options to ensure that our exported
                    'file for the Web is cropped to the right size!
                    exportDocument myFormat, myXnum & "-" & myYnum, mySaveFolder, False
                    For myNum = myApp.Documents(1).GroupItems(1).PageItems.Count To 2 Step -1
                        myApp.Documents(1).GroupItems(1).PageItems(myNum).MoveToBeginning (myApp.Documents(1))
                    Next
                    'Move all of the art in the document, except guides, into the group so it will get clipped.
                    myApp.Documents(1).GroupItems.Remove (myApp.Documents(1).GroupItems(1))
                    'Now we can remove the  group and clipping path in preparation for the next.*)
                Next
            Next
        End If
    End If
End Sub

Public Function OrderValues(myCurrentList, myInsert)
    Dim myLastItem, myInserted, myNum, myBackNum
    myLastItem = -1
    myInserted = False
    For myNum = 1 To UBound(myCurrentList)
        If myInsert > myLastItem And myInsert <= myCurrentList(myNum) Then
            If myNum = 1 Then
                ReDim Preserve myCurrentList(UBound(myCurrentList) + 1)
                For myBackNum = UBound(myCurrentList) - 1 To 1 Step -1
                    myCurrentList(myBackNum + 1) = myCurrentList(myBackNum)
                Next
                myCurrentList(1) = myInsert
            Else
                ReDim Preserve myCurrentList(UBound(myCurrentList) + 1)
                For myBackNum = UBound(myCurrentList) To myNum Step -1
                    myCurrentList(myBackNum) = myCurrentList(myBackNum - 1)
                Next
                myCurrentList(myNum) = myInsert
            End If
            myInserted = True
            Exit For
        End If
        myLastItem = myCurrentList(myNum)
    Next
    If myInserted = False Then
        ReDim Preserve myCurrentList(UBound(myCurrentList) + 1)
        myCurrentList(UBound(myCurrentList)) = myInsert
    End If
    OrderValues = myCurrentList
End Function

'4.06
Private Sub exportDocument(myFormat, myNameExtra, mySaveFolder, myRestoreFlag)
    Dim myOriginalFile, myNewPath, myCharNum, myExportOptions, myColor
    myOriginalFile = myApp.Documents(1).FullName
    If mySaveFolder <> "" Then
        myNewPath = mySaveFolder & "\"
        If Left(myOriginalFile, 1) <> "\" Then myNewPath = myNewPath & myApp.Documents(1).Name
    Else
        myNewPath = myOriginalFile
    End If
    If InStr(myOriginalFile, ".") > Len(myOriginalFile) - 5 Then
        myNewPath = Mid(myOriginalFile, 1, InStrRev(myOriginalFile, ".") - 1)
    End If
    myNewPath = myNewPath & myNameExtra
    Select Case myFormat
        Case "eps"
            myNewPath = myNewPath & ".eps"
            Set myExportOptions = New Illustrator.EPSSaveOptions
            myExportOptions.CMYKPostScript = True
            myExportOptions.Compatibility = aiIllustrator10
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedLinkedFiles = True
            myExportOptions.IncludeDocumentThumbnails = True
            myExportOptions.PostScript = aiLevel2
            myExportOptions.Preview = aiColorTIFF
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
        Case "flash"
            myNewPath = myNewPath & ".swf"
            Set myExportOptions = New Illustrator.ExportOptionsFlash
            myExportOptions.ArtBoardClipping = True
            myExportOptions.CurveQuality = 9
            myExportOptions.ExportStyle = aiLayersAsFrames
            myExportOptions.FrameRate = 15#
            myExportOptions.GenerateHTML = False
            myExportOptions.ImageFormat = aiLossy
            myExportOptions.JPEGMethod = aiJPEGOptimized
            myExportOptions.JPEGQuality = 7
            myExportOptions.Looping = False
            myExportOptions.ReadOnly = False
            myExportOptions.Replacing = aiSaveChanges
            myExportOptions.Resolution = 72#
            myApp.Documents(1).Export myNewPath, aiFlash, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
            
        Case "gif"
            myNewPath = myNewPath & ".gif"
            Set myExportOptions = New Illustrator.ExportOptionsGIF
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.InfoLossPercent = 0
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 0#
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiGIF, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "jpeg"
            myNewPath = myNewPath & ".jpg"
            Set myExportOptions = New Illustrator.ExportOptionsJPEG
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.BlurAmount = 0#
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.Optimization = True
            myExportOptions.QualitySetting = 70
            myExportOptions.SaveAsHTML = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiJPEG, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "pdf"
            myNewPath = myNewPath & ".pdf"
            Set myExportOptions = New Illustrator.PDFSaveOptions
            myExportOptions.ColorCompression = aiJPEGHigh
            myExportOptions.ColorDownsampling = 300#
            myExportOptions.Compatibility = aiAcrobat4
            myExportOptions.CompressArt = True
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedICCProfile = False
            myExportOptions.FontSubsetThreshold = 0#
            myExportOptions.GenerateThumbnails = True
            myExportOptions.GrayscaleCompression = aiJPEGHigh
            myExportOptions.GrayscaleDownsampling = 200#
            myExportOptions.MonochromeCompression = aiCCIT3
            myExportOptions.MonochromeDownsampling = 600#
            myExportOptions.PreserveEditability = False
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
        
        Case "png24"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New Illustrator.ExportOptionsPNG24
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiPNG24, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "png8"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New Illustrator.ExportOptionsPNG8
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256#
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 0
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiPNG8, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
            
        Case "svg"
            myNewPath = myNewPath & ".svg"
            Set myExportOptions = New Illustrator.ExportOptionsSVG
            myExportOptions.Compressed = False
            myExportOptions.CoordinatePrecision = 5
            myExportOptions.CSSProperties = aiStyleAttributes
            myExportOptions.DocumentEncoding = aiUTF8
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedRasterImages = True
            myExportOptions.FontSubsetting = aiAllGlyphs
            myExportOptions.IncludeFileInfo = True
            myExportOptions.IncludeVariablesAndDatasets = False
            myExportOptions.OptimizeForSVGViewer = True
            myExportOptions.PreserveEditability = False
            myExportOptions.Slices = True
            myApp.Documents(1).Export myNewPath, aiSVG, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
            
    End Select
End Sub
